# TODO: finish rust tools (vendor crates; crc32c crate seems x86_64 only?)
#
# Conditional build:
%bcond_with	rust	# rust based tools (thin_metadata_{pack,unpack})

Summary:	Tools for manipulating dm-thin device-mapper target metadata
Summary(pl.UTF-8):	Narzędzia do modyfikowania metadanych celów dm-thin device-mappera
Name:		thin-provisioning-tools
Version:	0.9.0
Release:	2
License:	GPL v3+
Group:		Applications/System
#Source0Download: https://github.com/jthornber/thin-provisioning-tools/releases
Source0:	https://github.com/jthornber/thin-provisioning-tools/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	b3ce6f476a5b7ea64c583e7d910d2db7
Patch0:		%{name}-sh.patch
URL:		https://github.com/jthornber/thin-provisioning-tools
BuildRequires:	autoconf >= 2.61
# for fresh config.sub
BuildRequires:	automake
BuildRequires:	boost-devel
BuildRequires:	expat-devel >= 1.95
BuildRequires:	gcc-c++ >= 6:4.0
BuildRequires:	libaio-devel
BuildRequires:	libstdc++-devel >= 6:4.0
%if %{with rust}
BuildRequires:	cargo
BuildRequires:	rust
%endif
Obsoletes:	device-mapper-persistent-data
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
A suite of tools for manipulating the metadata of the dm-thin
device-mapper target.

%description -l pl.UTF-8
Zestaw narzędzi do modyfikowania metadanych celów dm-thin
device-mappera.

%prep
%setup -q
%patch0 -p1

%build
cp -f /usr/share/automake/config.sub autoconf
%{__autoconf}
%configure \
	--with-optimisation=" "

%{__make} \
	CFLAGS="%{rpmcflags} %{rpmcppflags}" \
	CXXFLAGS="%{rpmcxxflags} %{rpmcppflags} -DSTRERROR_R_CHAR_P -std=c++11" \
	LDFLAGS="%{rpmldflags}" \
	V=

%if %{with rust}
%{__make} rust-tools
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	STRIP=:

%if %{with rust}
%{__make} install-rust-tools \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc CHANGES README.md TODO.org
%attr(755,root,root) %{_sbindir}/cache_check
%attr(755,root,root) %{_sbindir}/cache_dump
%attr(755,root,root) %{_sbindir}/cache_metadata_size
%attr(755,root,root) %{_sbindir}/cache_repair
%attr(755,root,root) %{_sbindir}/cache_restore
%attr(755,root,root) %{_sbindir}/cache_writeback
%attr(755,root,root) %{_sbindir}/era_check
%attr(755,root,root) %{_sbindir}/era_dump
%attr(755,root,root) %{_sbindir}/era_invalidate
%attr(755,root,root) %{_sbindir}/era_restore
%attr(755,root,root) %{_sbindir}/pdata_tools
%attr(755,root,root) %{_sbindir}/thin_check
%attr(755,root,root) %{_sbindir}/thin_delta
%attr(755,root,root) %{_sbindir}/thin_dump
%attr(755,root,root) %{_sbindir}/thin_ls
%attr(755,root,root) %{_sbindir}/thin_metadata_size
%attr(755,root,root) %{_sbindir}/thin_repair
%attr(755,root,root) %{_sbindir}/thin_restore
%attr(755,root,root) %{_sbindir}/thin_rmap
%attr(755,root,root) %{_sbindir}/thin_trim
%{_mandir}/man8/cache_check.8*
%{_mandir}/man8/cache_dump.8*
%{_mandir}/man8/cache_metadata_size.8*
%{_mandir}/man8/cache_repair.8*
%{_mandir}/man8/cache_restore.8*
%{_mandir}/man8/cache_writeback.8*
%{_mandir}/man8/era_check.8*
%{_mandir}/man8/era_dump.8*
%{_mandir}/man8/era_invalidate.8*
%{_mandir}/man8/era_restore.8*
%{_mandir}/man8/thin_check.8*
%{_mandir}/man8/thin_delta.8*
%{_mandir}/man8/thin_dump.8*
%{_mandir}/man8/thin_ls.8*
%{_mandir}/man8/thin_metadata_size.8*
%{_mandir}/man8/thin_repair.8*
%{_mandir}/man8/thin_restore.8*
%{_mandir}/man8/thin_rmap.8*
%{_mandir}/man8/thin_trim.8*
%if %{with rust}
%attr(755,root,root) %{_sbindir}/thin_metadata_pack
%attr(755,root,root) %{_sbindir}/thin_metadata_unpack
%{_mandir}/man8/thin_metadata_pack.8*
%{_mandir}/man8/thin_metadata_unpack.8*
%endif
%changelog
* Thu Aug 12 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/thin-provisioning-tools.git;a=log;h=master

* Thu Aug 12 2021 Jan Palus <atler@pld-linux.org> 3bda744
- boost rebuild

* Thu Aug 12 2021 Jan Palus <atler@pld-linux.org> 928e1ab
- don't strip binaries when installing

* Thu Aug 12 2021 Jan Palus <atler@pld-linux.org> b259d49
- fix passing compiler/linker flags

* Sun Oct 04 2020 Jan Palus <atler@pld-linux.org> 5c89d87
- refresh config.sub

* Wed Sep 23 2020 Jakub Bogusz <qboosh@pld-linux.org> 3935b18
- updated to 0.9.0; rust disabled by default

* Sun Oct 27 2019 Jakub Bogusz <qboosh@pld-linux.org> 72e956e
- updated to 0.8.5

* Sat Apr 28 2018 Jakub Bogusz <qboosh@pld-linux.org> 4276067
- updated to 0.7.6

* Tue Aug 01 2017 Jakub Bogusz <qboosh@pld-linux.org> 3f76519
- updated to 0.7.0

* Fri Oct 07 2016 Jakub Bogusz <qboosh@pld-linux.org> eee41c8
- updated to 0.6.3
- removed obsolete opt patch
- uses gnu++98 C++ dialect now

* Wed Apr 06 2016 Elan Ruusamäe <glen@delfi.ee> 73bf240
- obsolete fedora package name

* Tue Apr 05 2016 Jakub Bogusz <qboosh@pld-linux.org> 744901a
- updated to 0.6.1
- added sh patch (remove bashisms from configure)
- added opt patch, pass empty --with-optimisation to rely on CFLAGS/CXXFLAGS from environment

* Sun Jan 24 2016 Jakub Bogusz <qboosh@pld-linux.org> c8a0e91
- updated to 0.6.0

* Fri Sep 11 2015 Elan Ruusamäe <glen@delfi.ee> 1e5c658
- typo

* Wed Sep 09 2015 Jakub Bogusz <qboosh@pld-linux.org> 382ca02
- updated to 0.5.6

* Tue Dec 02 2014 Jakub Bogusz <qboosh@pld-linux.org> 224387e
- BR: libaio-devel

* Mon Dec 01 2014 Łukasz Krotowski <lkrotowski@pld-linux.org> 941913b
- up to 0.4.1

* Fri Sep 13 2013 Jakub Bogusz <qboosh@pld-linux.org> e3079f2
- new

